#!/usr/bin/perl
#
# This script checks the number of lines of the OCR output textfile with
# the XML file and prints out the results
# Requirements:
# 1. Textfile name: imagename.SelLabelsNoBoxes.txt
# 2. XML file name: imagename.SelMBs.xml
# 3. Both in the same folder
# Run with "runnumlines.bat"

opendir MYDIR, ".";

@files = readdir MYDIR;
closedir MYDIR;

foreach $entry (@files)
{
  if($entry =~ m/(.*)SelLabelsNoBoxes.txt/) {
    $filename = $1;
    $lines = 0;
    open(FILE, $entry) or die "Can't open `$entry': $!";
    while (sysread FILE, $buffer, 4096) {
      $lines += ($buffer =~ tr/\n//);
    }
    close FILE;

    $toappend = "SelMBs.xml";
    $xmlfile = $1 . $toappend;
    open (LOCATION, $xmlfile) || die "couldn't open '$xmlfile': $!";
    
    while ($record = <LOCATION>) {
      if($record =~ m/<NumLabels>(.*)<\/NumLabels>/) {
        $result = $1;
      }
    }
    
    if($lines != $result) {
      print $entry, " : ", $lines, " - ", $xmlfile, " : ", $result, "\n";
    } else {
      print $entry, " OK\n";
    }
    
    close(LOCATION);
  }
}

